package net.sourceforge.cathcart;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Reader;
import java.io.Writer;

import org.apache.tools.ant.BuildException;

/**
 * File copying utility.
 * 
 * @author Steven Hale
 * 
 */
public class FileCopier {
	/**
	 * Copies a file to another file. Throws BuildException if an IOException
	 * occurs
	 * 
	 * @param inFile
	 *            file to be copied
	 * @param outFile
	 *            file to copy to
	 */
	public void copy(File inFile, File outFile) {
		Writer writer = null;
		Reader reader = null;
		try {
			writer = new FileWriter(outFile);
			reader = new FileReader(inFile);
			int character;
			StringBuffer buffer = new StringBuffer();
			while ((character = reader.read()) != -1) {
				buffer.append(character);
				writer.write(character);
			}

		} catch (IOException e) {
			throw new BuildException("Can't copy " + inFile.getAbsolutePath()
					+ " to " + outFile.getAbsolutePath(), e);
		} finally {
			try {
				if (reader != null) {
					reader.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
			try {
				if (writer != null) {
					writer.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}

		}

	}

}
