package net.sourceforge.cathcart.typedefs;

import org.apache.tools.ant.BuildException;
/**
 * Compares the size of two operands when trend is expected to be downward.
 * @author Steven Hale
 *
 */
public class DownwardComparison extends SizeComparison {
    
	public boolean eval() throws BuildException {
		return (operandOne > limit());
	}

	protected double limit() {
		double leeway = this.leeway;
		if (absolute) {
			return operandTwo + leeway;
		}
		
		return operandTwo * (1.0 + leeway / 100);
	}

	@Override
	public String toString() {
		String out = "Checking that " + operandOne + " <= " + operandTwo;
		String sLeeway;
		if (leeway >= 0) {
			sLeeway = " + " + leeway;
		} else {
			sLeeway = " - " + (-leeway);
		}

		if (absolute) {
			return out + sLeeway + " ("
			+ limit() + ")";
		}
		
		return out + sLeeway + " %" + " ("
		+ limit() + ")";

	}

	@Override
	public String failedMessage() {
		String sLeeway;
		if (leeway >= 0) {
			sLeeway = " + " + leeway;

		} else {
			sLeeway = " - " + (-leeway);
		}
		if (!absolute) {
			sLeeway += " %";
		}
		return "Expected value to be less than " + operandTwo + sLeeway + " ("
				+ limit() + ") but was " + operandOne;
	}

}
